if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[d%.][d%.][O%.]ns\\PitBull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 39928 $"):match("%d+"))

local PitBull = PitBull
local PitBull_RestIcon = PitBull:NewModule("RestIcon", "AceEvent-2.0")
local self = PitBull_RestIcon
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-06-14 16:32:38 -0400 (Thu, 14 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = "Show an icon on the unit frame when the unit is resting in an inn or city."

local L = PitBull:L("PitBull-RestIcon")

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

PitBull_RestIcon:RegisterPitBullChildFrames('restIcon')

function PitBull_RestIcon:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("RestIcon")
	PitBull:RegisterDefaults("RestIcon", "profile", {
		disable = false,
	})
end

function PitBull_RestIcon:OnEnable()
	self:RegisterEvent("PLAYER_UPDATE_RESTING")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "PLAYER_UPDATE_RESTING")
end

function PitBull_RestIcon:PLAYER_UPDATE_RESTING(frame)
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			self:PLAYER_UPDATE_RESTING(frame)
		end
		return
	end
	
	local resting = IsResting()
	if resting and not self.db.profile.disable then
		if not frame.restIcon then
			frame.restIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.restIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
			frame.restIcon:SetTexCoord(0, 0.5, 0, 0.421875)
			frame.restIcon:Hide()
			PitBull:UpdateLayout(frame)
		end
	else
		if frame.restIcon then
			frame.restIcon = delFrame(frame.restIcon)
			
			PitBull:UpdateLayout(frame)
		end
	end
end

function PitBull_RestIcon:OnUpdateFrame(unit, frame)
	if unit == "player" then
		self:PLAYER_UPDATE_RESTING(frame)
	end
end

function PitBull_RestIcon:OnClearUnitFrame(unit, frame)
	if frame.restIcon then
		frame.restIcon = delFrame(frame.restIcon)
	end
end

function PitBull_RestIcon:OnUnknownLayout(unit, frame)
	if frame.combatIcon then
		frame.restIcon:SetPoint("LEFT", frame.combatIcon, "RIGHT", 4, 0)
	else
		frame.restIcon:SetPoint("CENTER", frame, "BOTTOMLEFT", 0, 0)
	end
	frame.restIcon:SetWidth(18)
	frame.restIcon:SetHeight(18)
end

PitBull_RestIcon:RegisterPitBullOptionsMethod(function(group)
	if group == "player" then
		return {
			type = "toggle",
			name = L["Enable resting icon"],
			desc = L["Enables the icon indicating whether or not the player is currently resting."],
			get = function()
				return not self.db.profile.disable
			end,
			set = function(value)
				self.db.profile.disable = not value
				self:PLAYER_UPDATE_RESTING()
			end,
		}
	end
end)
